<?php

	// Authors: 
	//		Brian N. Smith  -      NuOnce Networks      - http://www.nuonce.net
	//		Michael Stauber - Stauber Multimedia Design - http://www.solarspeed.net
	// Copyright 2006, NuOnce Networks & Stauber Multimedia Design. All rights reserved.

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();

//Only users with adminUser capability should be here
if (!$serverScriptHelper->getAllowed('adminUser')) {
    header("location: /error/forbidden.html");
    return;
}

$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("nusolYum", "/nuonce-solarspeed/yum/yumgui.php");
$transMethodOn="off";

if ( $_save == "1" ) {
	$cceClient->setObject("System",
         array(
              "autoupdate" => $autoupdate, 
              "y_force_update" => $y_force_update,
              "yumguiEMAIL" => $yumguiEMAIL,
              "yumguiEMAILADDY" => $yumguiEMAILADDY,
              "yumUpdateTime" => $yumUpdateTime,
              "yumUpdateSU" => $yumUpdateSU,
              "yumUpdateMO" => $yumUpdateMO,
              "yumUpdateTU" => $yumUpdateTU,
              "yumUpdateWE" => $yumUpdateWE,
              "yumUpdateTH" => $yumUpdateTH,
              "yumUpdateFR" => $yumUpdateFR,
              "yumUpdateSA" => $yumUpdateSA),
              "nusolYum");
	$errors = $cceClient->errors();
}

// get settings
$systemObj = $cceClient->getObject("System",array(),"nusolYum");

$page = $factory->getPage();

$block = $factory->getPagedBlock("yumgui_head", array("Available updates", "Settings", "Logs"));
$block->processErrors($serverScriptHelper->getErrors());

// Force Update of CODB:
mt_srand((double)microtime() * 1000000);
$zufall = mt_rand();
$force_update_Field = $factory->getTextField("y_force_update", $zufall);
$force_update_Field->setOptional ('silent');
$block->addFormField(
    $force_update_Field,
    $factory->getLabel("y_force_update"),
  "hidden"
);

// Settings:
if($systemObj["autoupdate"] == "On") {
        $autoupdate_choices=array("autoupdate_yes" => "On", "autoupdate_no" => "Off");
}
else {
//Strict, but safe default:
        $autoupdate_choices=array("autoupdate_no" => "Off", "autoupdate_yes" => "On");
}

// Display YUM enabler switch:
$autoupdate_select = $factory->getMultiChoice("autoupdate",array_values($autoupdate_choices));
$autoupdate_select->setSelected($autoupdate_choices[$autoupdate], true);
$block->addFormField($autoupdate_select,$factory->getLabel("autoupdate"), "Settings");

$block->addFormField(
  $factory->getBoolean("yumguiEMAIL", $systemObj["yumguiEMAIL"]),
  $factory->getLabel("yumguiEMAIL"),
  "Settings"
  );

$yumguiEMAILADDYField = $factory->getTextField("yumguiEMAILADDY", $systemObj['yumguiEMAILADDY']);
$yumguiEMAILADDYField->setOptional ('silent');
$block->addFormField(
    $yumguiEMAILADDYField,
    $factory->getLabel("yumguiEMAILADDY"),
    "Settings"
);

$time_to_update = array();
for ($i = 0; $i < 24 ; $i++ ) {
    $time_to_update []= "$i:00";
    $time_to_update []= "$i:30";
}

$yumUpdateTime= $factory->getMultiChoice("yumUpdateTime", $time_to_update);
$yumUpdateTime->setSelected($systemObj["yumUpdateTime"], true);
$block->addFormField(
   $yumUpdateTime,
   $factory->getLabel("yumUpdateTime"),
   "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateSU", $systemObj["yumUpdateSU"]),
  $factory->getLabel("yumUpdateSU"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateMO", $systemObj["yumUpdateMO"]),
  $factory->getLabel("yumUpdateMO"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateTU", $systemObj["yumUpdateTU"]),
  $factory->getLabel("yumUpdateTU"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateWE", $systemObj["yumUpdateWE"]),
  $factory->getLabel("yumUpdateWE"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateTH", $systemObj["yumUpdateTH"]),
  $factory->getLabel("yumUpdateTH"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateFR", $systemObj["yumUpdateFR"]),
  $factory->getLabel("yumUpdateFR"),
  "Settings"
);

$block->addFormField(
  $factory->getBoolean("yumUpdateSA", $systemObj["yumUpdateSA"]),
  $factory->getLabel("yumUpdateSA"),
  "Settings"
);

if ($_PagedBlock_selectedId_yumgui_head == "Settings") {
    $block->addButton($factory->getSaveButton($page->getSubmitAction()));
}

// Display date of last update:
if ( file_exists("/var/log/yum.log") ) {
	//$yum_last_updated = $serverScriptHelper->getFile("/tmp/yum.update-date"); // I think it's better to get the date from the logfile instead:
	$yum_last_updated = `/usr/bin/stat /var/log/yum.log |grep "Modify:"|sed 's/Modify: //g'|sed 's/\..*//g'`;
	$block->addFormField(
	$factory->getTextField("yum_last_updated", $yum_last_updated, "r"),
	$factory->getLabel("yum_last_updated"), "Available updates"
  	);
}

// Display notice that system is currently installing updates:
if ( file_exists("/tmp/yum.updating") ) {
	$yum_is_pulling_updates = "This system is currently being updated. Please check back in a couple of minutes.";
	$block->addFormField(
	$factory->getTextField("yum_is_pulling_updates", $yum_is_pulling_updates, "r"),
	$factory->getLabel("yum_is_pulling_updates"), "Available updates"
  	);
}

// Logfile viewer:
$datei_yum = "/var/log/yum.log";
$array_yum = file($datei_yum);
$array_yum = array_reverse($array_yum);

for($x=0;$x<count($array_yum);$x++){
        // Replace
        $array_yum[$x] = nl2br($array_yum[$x]); //#newline conversion
        $array_yum[$x] = br2nl($array_yum[$x]);
	if ($x < 500) {
	        $the_file_data = $the_file_data.$array_yum[$x];
	}
}

$tfd_num = count($the_file_data);
if ($tfd_num < 1) {
    $the_file_data = "Logfile appears to be empty.";
}

$GLOBALS["_FormField_height"] = 40;
$GLOBALS["_FormField_width"] = 90;


$block->addFormField(
  $factory->getTextBlock("yumlog", $the_file_data),
  $factory->getLabel("yumlog"),
  "Logs"
);

// Get update list:
$yum = $factory->getScrollList("yumTitle",
	array("name", "version", "status"), array(0,1,2));
$yum->setDefaultSortedIndex(0);
$yum->addButton($factory->getButton("/nuonce-solarspeed/yum/yumCheck.php", "yumCheck"));

$serverScriptHelper->destructor();

print($page->toHeaderHtml()); 
print($block->toHtml()); 

	$yum_output = file_get_contents("/tmp/yum.check-update");

        $a_yum = split("\n", $yum_output);
        $count = count($a_yum);
        $start = 0;
        for ( $i = 0; $i < $count; $i++ ) {
                if ( $a_yum[$i] == "" ) { $start = 1; }
                if ( $start == 1 AND $a_yum[$i] ) {
                        $updates[] = $a_yum[$i];
                }
        }

	if(isset($updates) && count($updates) > 0 ) { 
	        foreach ( $updates as $entry ) {
        	        $yum_update = 1;
                	$entry = preg_replace("/\s+/", " ", $entry);
	                $a_entry = split(" ", $entry);
        	        $yum->addEntry(array(
                	        $factory->getTextField("", $a_entry[0], "r"),
                        	$factory->getTextField("", $a_entry[1], "r"),
	                        $factory->getTextField("", $a_entry[2], "r")
        	        ));
	        }
	}

        $button = $factory->getButton("/nuonce-solarspeed/yum/yumUpdate.php", "yumNOW");

	// Only display table of updates if ...
	//	we're on the tab labled "Available updates" - the OR makes sure that default page views w/o clicking a tab also work
	//	AND we're not already busy pulling updates	  
	if ((($_PagedBlock_selectedId_yumgui_head == "Available updates") || ($_PagedBlock_selectedId_yumgui_head == "")) && (!$yum_is_pulling_updates)) { 
	    echo $yum->toHtml();
            echo "<br>";
            if ( $yum_update ) {
                    echo $button->toHtml();
            }
	} 
	
?>
<?php print($page->toFooterHtml()); ?>

<?php
function br2nl($str) {
   $str = preg_replace("/(\r\n|\n|\r)/", "", $str);
   return preg_replace("=<br */?>=i", "\n", $str);
}
?>

